# -*- coding: utf-8 -*-

# 程式編寫人 : Ken Ng
# 網址 : https://www.kenng.hk
# 電郵 : ken@kenng.hk
# 程式用途 : 節省每天核對確診大廈名單的朋友

import sys
try:
    import requests
except ModuleNotFoundError:
    print("請安裝 requests 模組, 在 '命令提示字元' 執行 'pip3 install requests' ")
    input("按任何鍵離開程式 .......... ")
    sys.exit("Quit")
    
try:
    import tabula
except ModuleNotFoundError:
    print("請安裝 tabula-py 模組, 在 '命令提示字元' 執行 'pip3 install tabula-py' ")
    input("按任何鍵離開程式 .......... ")
    sys.exit("Quit")
try:
    from openpyxl import Workbook
except ModuleNotFoundError:
    print("請安裝 openpyxl 模組, 在 '命令提示字元' 執行 'pip3 install openpyxl' ")
    input("按任何鍵離開程式 .......... ")
    sys.exit("Quit")    
try:
    from datetime import datetime
except ModuleNotFoundError:
    print("請安裝 datetime 模組, 在 '命令提示字元' 執行 'pip3 install datetime' ")        
    input("按任何鍵離開程式 .......... ")
    sys.exit("Quit")    
#import requests
#import tabula
import time
import csv
import os
#from openpyxl import Workbook
from re import search 
#from datetime import datetime

start_time = time.time()
ofile = "building_list_chi.pdf"
cfile = "data.csv"
dfile = "udata.csv"
rfile = "record.csv"
aemail = "email.csv"
aexcel = "checklist.xlsx"

###### 讀取當前時間 ######
def date_now():
    now = datetime.now()
    dt_string = now.strftime("%d/%m/%Y %H:%M:%S")
    return dt_string



if os.path.exists(ofile):
   try:  
       os.remove(ofile)
   except IOError:
       print("\n")
       print("程式未被執行 .......")
       print("\n")       
       print("building_list_chi.pdf 正在使用中... 請關閉後再重新執行")
       print("\n")
       input("按任何鍵離開程式 .......... ")
       quit()
       
if not os.path.isfile(dfile):
   with open(dfile,"w+",encoding="utf-8") as r_file:
       while True:
        inputdata = input("請輸入你想追蹤的大廈名,離開按'Q' : ")
        if inputdata == 'Q' or inputdata == 'q':
            break;
        else:
            if inputdata=="":
               print("你輸入的是空白字串,請重新輸入")
            else:
               r_file.write(inputdata+",")
   r_file.close()

url = 'https://www.chp.gov.hk/files/pdf/building_list_chi.pdf'
r = requests.get(url, allow_redirects=True)

open(ofile, 'wb').write(r.content)

tabula.convert_into(ofile, cfile, output_format="csv", pages='all',java_options="-Dfile.encoding=UTF8")

#print("--- %s seconds ---" % (time.time() - start_time))


ddtime=date_now()

udata = [] # 用戶追蹤名單
source = [] # 政府公佈大廈名單
record = [] # 記錄匹配大廈名及追蹤日期

try:
    with open(rfile,encoding="utf-8") as r_file:
        r_reader = csv.reader(r_file)
        for row in r_reader:
            if len(row) > 0:
               if row[3] == "1":
                  record.append(row)
    r_file.close() 
    os.remove(rfile)    
except IOError:
    print("記錄檔案 record.csv 創建")

ccoo=0
with open(cfile,encoding="utf-8") as c_file, open(dfile,encoding="utf-8") as d_file, open(rfile,"w+",encoding="utf-8") as r_file:
    d_reader = csv.reader(d_file)
    c_reader = csv.reader(c_file)
    r_writer = csv.writer(r_file,delimiter=',')
    for row in d_reader:
        udata.append(row)
    for row in c_reader:
        source.append(row)

    for urow in udata:
    #   print (urow[0])
       ccoo=0
       for srow in source:
          r_srow=srow[1].replace(" ","")
          r_urow=urow[0].replace(" ","")
          if r_srow.find(r_urow)>=0:
             if ccoo == 0:
                 print(ddtime+" 注意 - "+urow[0]+" - 你指定的樓宇在14日內有曾居住/到訪的感染者")
             ccoo=ccoo+1
             if len(srow) > 2:
                 print (srow[0]+" "+srow[1]+" "+srow[2])
             else:
                 print (srow[0]+" "+srow[1])
#             print (record)
             if len(record) <= 0:
                y = [srow[0],srow[1],ddtime,"1",urow[0]]
                record.append(y)
             else: 
                crd=0
                for rrow in record:
                   r_srow=srow[1].replace(" ","")
                   r_rrow=rrow[1].replace(" ","")
                   if r_srow.find(r_rrow) >= 0:
                       crd=1
                   else:
                       ccrd=0
                       ccrd1=0
                       for ssrow in source:
                           r_ssrow=ssrow[1].replace(" ","")
                           r_rrow=rrow[1].replace(" ","")
                           if r_rrow.find(r_ssrow) >= 0:
                               ccrd=1
                       for uurow in udata:
                           r_rrow4=rrow[4].replace(" ","")
                           r_uurow=uurow[0].replace(" ","")                       
                           if r_rrow4.find(r_uurow) >= 0:
                               ccrd1=1
                       if ccrd==0 or ccrd1==0:
                          rrow[3]=0  

                if crd==0:
                   y = [srow[0],srow[1],ddtime,"1",urow[0]]
                   record.append(y)
    
       if ccoo == 0:
          print (ddtime+" 你指定的樓宇 "+urow[0]+" 在14日內沒有曾居住/到訪的感染者")
          print ("-------------------------------------")
          print (" ")
    print ("下載 PDF FILE "+url+" ")
    print (" ")
    print (" checklist.xlsx 已更新 .... ")

    r_writer.writerows(record)
c_file.close() 
d_file.close() 
r_file.close() 


f=open(aemail,"w",encoding="utf-8")
f.write("追蹤指定大廈明單 --- 匹配 --- 衛生署公告曾有確診或疑似2019冠狀病毒病個案的大廈名單")
f.write("\n")
f.write("\n")
f.write("\n")
f.write("地區,衛生署公告大廈名稱,追蹤發現日期,*備註欄,追蹤指定大廈")
f.write("\n")
for row in record:
    f.write(str(row[0])+","+str(row[1])+","+str(row[2])+","+str(row[3])+","+str(row[4]))
    f.write("\n")
f.write("\n")
f.write("*備註欄:")
f.write("\n")
f.write("1 -代表還在衛生署公告名單內")
f.write("\n")
f.write("0 -代表已經移出衛生署公告名單內或追蹤名單已改變 ")
f.write("\n")
f.write("\n")
f.write("\n")
f.write("已更新 checklist.xlsx")
f.close

wb = Workbook()
ws = wb.active
with open(aemail, 'r',encoding="utf-8") as f:
    for row in csv.reader(f):
        ws.append(row)
ws.column_dimensions['A'].width = 15
ws.column_dimensions['B'].width = 40
ws.column_dimensions['C'].width = 20
ws.column_dimensions['D'].width = 10
ws.column_dimensions['E'].width = 15
wb.save(aexcel)

input("按任何鍵離開程式 .......... ")
